t / test-lib.shon commit Sync with 1.7.1.1 (c9eaaab)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset GIT_EDITOR
  47unset AUTHOR_DATE
  48unset AUTHOR_EMAIL
  49unset AUTHOR_NAME
  50unset COMMIT_AUTHOR_EMAIL
  51unset COMMIT_AUTHOR_NAME
  52unset EMAIL
  53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  54unset GIT_AUTHOR_DATE
  55GIT_AUTHOR_EMAIL=author@example.com
  56GIT_AUTHOR_NAME='A U Thor'
  57unset GIT_COMMITTER_DATE
  58GIT_COMMITTER_EMAIL=committer@example.com
  59GIT_COMMITTER_NAME='C O Mitter'
  60unset GIT_DIFF_OPTS
  61unset GIT_DIR
  62unset GIT_WORK_TREE
  63unset GIT_EXTERNAL_DIFF
  64unset GIT_INDEX_FILE
  65unset GIT_OBJECT_DIRECTORY
  66unset GIT_CEILING_DIRECTORIES
  67unset SHA1_FILE_DIRECTORIES
  68unset SHA1_FILE_DIRECTORY
  69unset GIT_NOTES_REF
  70unset GIT_NOTES_DISPLAY_REF
  71unset GIT_NOTES_REWRITE_REF
  72unset GIT_NOTES_REWRITE_MODE
  73GIT_MERGE_VERBOSITY=5
  74export GIT_MERGE_VERBOSITY
  75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  77export EDITOR
  78
  79# Protect ourselves from common misconfiguration to export
  80# CDPATH into the environment
  81unset CDPATH
  82
  83unset GREP_OPTIONS
  84
  85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  86        1|2|true)
  87                echo "* warning: Some tests will not work if GIT_TRACE" \
  88                        "is set as to trace on STDERR ! *"
  89                echo "* warning: Please set GIT_TRACE to something" \
  90                        "other than 1, 2 or true ! *"
  91                ;;
  92esac
  93
  94# Convenience
  95#
  96# A regexp to match 5 and 40 hexdigits
  97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  99
 100# Each test should start with something like this, after copyright notices:
 101#
 102# test_description='Description of this test...
 103# This test checks if command xyzzy does the right thing...
 104# '
 105# . ./test-lib.sh
 106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 107                TERM=$ORIGINAL_TERM &&
 108                export TERM &&
 109                [ -t 1 ] &&
 110                tput bold >/dev/null 2>&1 &&
 111                tput setaf 1 >/dev/null 2>&1 &&
 112                tput sgr0 >/dev/null 2>&1
 113        ) &&
 114        color=t
 115
 116while test "$#" -ne 0
 117do
 118        case "$1" in
 119        -d|--d|--de|--deb|--debu|--debug)
 120                debug=t; shift ;;
 121        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 122                immediate=t; shift ;;
 123        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 124                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 125        -h|--h|--he|--hel|--help)
 126                help=t; shift ;;
 127        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 128                verbose=t; shift ;;
 129        -q|--q|--qu|--qui|--quie|--quiet)
 130                quiet=t; shift ;;
 131        --with-dashes)
 132                with_dashes=t; shift ;;
 133        --no-color)
 134                color=; shift ;;
 135        --no-python)
 136                # noop now...
 137                shift ;;
 138        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 139                valgrind=t; verbose=t; shift ;;
 140        --tee)
 141                shift ;; # was handled already
 142        --root=*)
 143                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 144                shift ;;
 145        *)
 146                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 147        esac
 148done
 149
 150if test -n "$color"; then
 151        say_color () {
 152                (
 153                TERM=$ORIGINAL_TERM
 154                export TERM
 155                case "$1" in
 156                        error) tput bold; tput setaf 1;; # bold red
 157                        skip)  tput bold; tput setaf 2;; # bold green
 158                        pass)  tput setaf 2;;            # green
 159                        info)  tput setaf 3;;            # brown
 160                        *) test -n "$quiet" && return;;
 161                esac
 162                shift
 163                printf "* %s" "$*"
 164                tput sgr0
 165                echo
 166                )
 167        }
 168else
 169        say_color() {
 170                test -z "$1" && test -n "$quiet" && return
 171                shift
 172                echo "* $*"
 173        }
 174fi
 175
 176error () {
 177        say_color error "error: $*"
 178        GIT_EXIT_OK=t
 179        exit 1
 180}
 181
 182say () {
 183        say_color info "$*"
 184}
 185
 186test "${test_description}" != "" ||
 187error "Test script did not set test_description."
 188
 189if test "$help" = "t"
 190then
 191        echo "$test_description"
 192        exit 0
 193fi
 194
 195exec 5>&1
 196if test "$verbose" = "t"
 197then
 198        exec 4>&2 3>&1
 199else
 200        exec 4>/dev/null 3>/dev/null
 201fi
 202
 203test_failure=0
 204test_count=0
 205test_fixed=0
 206test_broken=0
 207test_success=0
 208
 209die () {
 210        code=$?
 211        if test -n "$GIT_EXIT_OK"
 212        then
 213                exit $code
 214        else
 215                echo >&5 "FATAL: Unexpected exit with code $code"
 216                exit 1
 217        fi
 218}
 219
 220GIT_EXIT_OK=
 221trap 'die' EXIT
 222
 223# The semantics of the editor variables are that of invoking
 224# sh -c "$EDITOR \"$@\"" files ...
 225#
 226# If our trash directory contains shell metacharacters, they will be
 227# interpreted if we just set $EDITOR directly, so do a little dance with
 228# environment variables to work around this.
 229#
 230# In particular, quoting isn't enough, as the path may contain the same quote
 231# that we're using.
 232test_set_editor () {
 233        FAKE_EDITOR="$1"
 234        export FAKE_EDITOR
 235        EDITOR='"$FAKE_EDITOR"'
 236        export EDITOR
 237}
 238
 239test_decode_color () {
 240        sed     -e 's/.\[1m/<WHITE>/g' \
 241                -e 's/.\[31m/<RED>/g' \
 242                -e 's/.\[32m/<GREEN>/g' \
 243                -e 's/.\[33m/<YELLOW>/g' \
 244                -e 's/.\[34m/<BLUE>/g' \
 245                -e 's/.\[35m/<MAGENTA>/g' \
 246                -e 's/.\[36m/<CYAN>/g' \
 247                -e 's/.\[m/<RESET>/g'
 248}
 249
 250q_to_nul () {
 251        perl -pe 'y/Q/\000/'
 252}
 253
 254q_to_cr () {
 255        tr Q '\015'
 256}
 257
 258append_cr () {
 259        sed -e 's/$/Q/' | tr Q '\015'
 260}
 261
 262remove_cr () {
 263        tr '\015' Q | sed -e 's/Q$//'
 264}
 265
 266test_tick () {
 267        if test -z "${test_tick+set}"
 268        then
 269                test_tick=1112911993
 270        else
 271                test_tick=$(($test_tick + 60))
 272        fi
 273        GIT_COMMITTER_DATE="$test_tick -0700"
 274        GIT_AUTHOR_DATE="$test_tick -0700"
 275        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 276}
 277
 278# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 279#
 280# This will commit a file with the given contents and the given commit
 281# message.  It will also add a tag with <message> as name.
 282#
 283# Both <file> and <contents> default to <message>.
 284
 285test_commit () {
 286        file=${2:-"$1.t"}
 287        echo "${3-$1}" > "$file" &&
 288        git add "$file" &&
 289        test_tick &&
 290        git commit -m "$1" &&
 291        git tag "$1"
 292}
 293
 294# Call test_merge with the arguments "<message> <commit>", where <commit>
 295# can be a tag pointing to the commit-to-merge.
 296
 297test_merge () {
 298        test_tick &&
 299        git merge -m "$1" "$2" &&
 300        git tag "$1"
 301}
 302
 303# This function helps systems where core.filemode=false is set.
 304# Use it instead of plain 'chmod +x' to set or unset the executable bit
 305# of a file in the working directory and add it to the index.
 306
 307test_chmod () {
 308        chmod "$@" &&
 309        git update-index --add "--chmod=$@"
 310}
 311
 312# Use test_set_prereq to tell that a particular prerequisite is available.
 313# The prerequisite can later be checked for in two ways:
 314#
 315# - Explicitly using test_have_prereq.
 316#
 317# - Implicitly by specifying the prerequisite tag in the calls to
 318#   test_expect_{success,failure,code}.
 319#
 320# The single parameter is the prerequisite tag (a simple word, in all
 321# capital letters by convention).
 322
 323test_set_prereq () {
 324        satisfied="$satisfied$1 "
 325}
 326satisfied=" "
 327
 328test_have_prereq () {
 329        case $satisfied in
 330        *" $1 "*)
 331                : yes, have it ;;
 332        *)
 333                ! : nope ;;
 334        esac
 335}
 336
 337# You are not expected to call test_ok_ and test_failure_ directly, use
 338# the text_expect_* functions instead.
 339
 340test_ok_ () {
 341        test_success=$(($test_success + 1))
 342        say_color "" "  ok $test_count: $@"
 343}
 344
 345test_failure_ () {
 346        test_failure=$(($test_failure + 1))
 347        say_color error "FAIL $test_count: $1"
 348        shift
 349        echo "$@" | sed -e 's/^/        /'
 350        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 351}
 352
 353test_known_broken_ok_ () {
 354        test_fixed=$(($test_fixed+1))
 355        say_color "" "  FIXED $test_count: $@"
 356}
 357
 358test_known_broken_failure_ () {
 359        test_broken=$(($test_broken+1))
 360        say_color skip "  still broken $test_count: $@"
 361}
 362
 363test_debug () {
 364        test "$debug" = "" || eval "$1"
 365}
 366
 367test_run_ () {
 368        test_cleanup=:
 369        eval >&3 2>&4 "$1"
 370        eval_ret=$?
 371        eval >&3 2>&4 "$test_cleanup"
 372        return 0
 373}
 374
 375test_skip () {
 376        test_count=$(($test_count+1))
 377        to_skip=
 378        for skp in $GIT_SKIP_TESTS
 379        do
 380                case $this_test.$test_count in
 381                $skp)
 382                        to_skip=t
 383                esac
 384        done
 385        if test -z "$to_skip" && test -n "$prereq" &&
 386           ! test_have_prereq "$prereq"
 387        then
 388                to_skip=t
 389        fi
 390        case "$to_skip" in
 391        t)
 392                say_color skip >&3 "skipping test: $@"
 393                say_color skip "skip $test_count: $1"
 394                : true
 395                ;;
 396        *)
 397                false
 398                ;;
 399        esac
 400}
 401
 402test_expect_failure () {
 403        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 404        test "$#" = 2 ||
 405        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 406        if ! test_skip "$@"
 407        then
 408                say >&3 "checking known breakage: $2"
 409                test_run_ "$2"
 410                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 411                then
 412                        test_known_broken_ok_ "$1"
 413                else
 414                        test_known_broken_failure_ "$1"
 415                fi
 416        fi
 417        echo >&3 ""
 418}
 419
 420test_expect_success () {
 421        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 422        test "$#" = 2 ||
 423        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 424        if ! test_skip "$@"
 425        then
 426                say >&3 "expecting success: $2"
 427                test_run_ "$2"
 428                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 429                then
 430                        test_ok_ "$1"
 431                else
 432                        test_failure_ "$@"
 433                fi
 434        fi
 435        echo >&3 ""
 436}
 437
 438test_expect_code () {
 439        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 440        test "$#" = 3 ||
 441        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
 442        if ! test_skip "$@"
 443        then
 444                say >&3 "expecting exit code $1: $3"
 445                test_run_ "$3"
 446                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 447                then
 448                        test_ok_ "$2"
 449                else
 450                        test_failure_ "$@"
 451                fi
 452        fi
 453        echo >&3 ""
 454}
 455
 456# test_external runs external test scripts that provide continuous
 457# test output about their progress, and succeeds/fails on
 458# zero/non-zero exit code.  It outputs the test output on stdout even
 459# in non-verbose mode, and announces the external script with "* run
 460# <n>: ..." before running it.  When providing relative paths, keep in
 461# mind that all scripts run in "trash directory".
 462# Usage: test_external description command arguments...
 463# Example: test_external 'Perl API' perl ../path/to/test.pl
 464test_external () {
 465        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 466        test "$#" = 3 ||
 467        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 468        descr="$1"
 469        shift
 470        if ! test_skip "$descr" "$@"
 471        then
 472                # Announce the script to reduce confusion about the
 473                # test output that follows.
 474                say_color "" " run $test_count: $descr ($*)"
 475                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 476                # to be able to use them in script
 477                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 478                # Run command; redirect its stderr to &4 as in
 479                # test_run_, but keep its stdout on our stdout even in
 480                # non-verbose mode.
 481                "$@" 2>&4
 482                if [ "$?" = 0 ]
 483                then
 484                        test_ok_ "$descr"
 485                else
 486                        test_failure_ "$descr" "$@"
 487                fi
 488        fi
 489}
 490
 491# Like test_external, but in addition tests that the command generated
 492# no output on stderr.
 493test_external_without_stderr () {
 494        # The temporary file has no (and must have no) security
 495        # implications.
 496        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 497        stderr="$tmp/git-external-stderr.$$.tmp"
 498        test_external "$@" 4> "$stderr"
 499        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 500        descr="no stderr: $1"
 501        shift
 502        say >&3 "expecting no stderr from previous command"
 503        if [ ! -s "$stderr" ]; then
 504                rm "$stderr"
 505                test_ok_ "$descr"
 506        else
 507                if [ "$verbose" = t ]; then
 508                        output=`echo; echo Stderr is:; cat "$stderr"`
 509                else
 510                        output=
 511                fi
 512                # rm first in case test_failure exits.
 513                rm "$stderr"
 514                test_failure_ "$descr" "$@" "$output"
 515        fi
 516}
 517
 518# This is not among top-level (test_expect_success | test_expect_failure)
 519# but is a prefix that can be used in the test script, like:
 520#
 521#       test_expect_success 'complain and die' '
 522#           do something &&
 523#           do something else &&
 524#           test_must_fail git checkout ../outerspace
 525#       '
 526#
 527# Writing this as "! git checkout ../outerspace" is wrong, because
 528# the failure could be due to a segv.  We want a controlled failure.
 529
 530test_must_fail () {
 531        "$@"
 532        test $? -gt 0 -a $? -le 129 -o $? -gt 192
 533}
 534
 535# Similar to test_must_fail, but tolerates success, too.  This is
 536# meant to be used in contexts like:
 537#
 538#       test_expect_success 'some command works without configuration' '
 539#               test_might_fail git config --unset all.configuration &&
 540#               do something
 541#       '
 542#
 543# Writing "git config --unset all.configuration || :" would be wrong,
 544# because we want to notice if it fails due to segv.
 545
 546test_might_fail () {
 547        "$@"
 548        test $? -ge 0 -a $? -le 129 -o $? -gt 192
 549}
 550
 551# test_cmp is a helper function to compare actual and expected output.
 552# You can use it like:
 553#
 554#       test_expect_success 'foo works' '
 555#               echo expected >expected &&
 556#               foo >actual &&
 557#               test_cmp expected actual
 558#       '
 559#
 560# This could be written as either "cmp" or "diff -u", but:
 561# - cmp's output is not nearly as easy to read as diff -u
 562# - not all diff versions understand "-u"
 563
 564test_cmp() {
 565        $GIT_TEST_CMP "$@"
 566}
 567
 568# This function can be used to schedule some commands to be run
 569# unconditionally at the end of the test to restore sanity:
 570#
 571#       test_expect_success 'test core.capslock' '
 572#               git config core.capslock true &&
 573#               test_when_finished "git config --unset core.capslock" &&
 574#               hello world
 575#       '
 576#
 577# That would be roughly equivalent to
 578#
 579#       test_expect_success 'test core.capslock' '
 580#               git config core.capslock true &&
 581#               hello world
 582#               git config --unset core.capslock
 583#       '
 584#
 585# except that the greeting and config --unset must both succeed for
 586# the test to pass.
 587
 588test_when_finished () {
 589        test_cleanup="{ $*
 590                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 591}
 592
 593# Most tests can use the created repository, but some may need to create more.
 594# Usage: test_create_repo <directory>
 595test_create_repo () {
 596        test "$#" = 1 ||
 597        error "bug in the test script: not 1 parameter to test-create-repo"
 598        owd=`pwd`
 599        repo="$1"
 600        mkdir -p "$repo"
 601        cd "$repo" || error "Cannot setup test environment"
 602        "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
 603        error "cannot run git init -- have you built things yet?"
 604        mv .git/hooks .git/hooks-disabled
 605        cd "$owd"
 606}
 607
 608test_done () {
 609        GIT_EXIT_OK=t
 610        test_results_dir="$TEST_DIRECTORY/test-results"
 611        mkdir -p "$test_results_dir"
 612        test_results_path="$test_results_dir/${0%.sh}-$$"
 613
 614        echo "total $test_count" >> $test_results_path
 615        echo "success $test_success" >> $test_results_path
 616        echo "fixed $test_fixed" >> $test_results_path
 617        echo "broken $test_broken" >> $test_results_path
 618        echo "failed $test_failure" >> $test_results_path
 619        echo "" >> $test_results_path
 620
 621        if test "$test_fixed" != 0
 622        then
 623                say_color pass "fixed $test_fixed known breakage(s)"
 624        fi
 625        if test "$test_broken" != 0
 626        then
 627                say_color error "still have $test_broken known breakage(s)"
 628                msg="remaining $(($test_count-$test_broken)) test(s)"
 629        else
 630                msg="$test_count test(s)"
 631        fi
 632        case "$test_failure" in
 633        0)
 634                say_color pass "passed all $msg"
 635
 636                test -d "$remove_trash" &&
 637                cd "$(dirname "$remove_trash")" &&
 638                rm -rf "$(basename "$remove_trash")"
 639
 640                exit 0 ;;
 641
 642        *)
 643                say_color error "failed $test_failure among $msg"
 644                exit 1 ;;
 645
 646        esac
 647}
 648
 649# Test the binaries we have just built.  The tests are kept in
 650# t/ subdirectory and are run in 'trash directory' subdirectory.
 651TEST_DIRECTORY=$(pwd)
 652if test -n "$valgrind"
 653then
 654        make_symlink () {
 655                test -h "$2" &&
 656                test "$1" = "$(readlink "$2")" || {
 657                        # be super paranoid
 658                        if mkdir "$2".lock
 659                        then
 660                                rm -f "$2" &&
 661                                ln -s "$1" "$2" &&
 662                                rm -r "$2".lock
 663                        else
 664                                while test -d "$2".lock
 665                                do
 666                                        say "Waiting for lock on $2."
 667                                        sleep 1
 668                                done
 669                        fi
 670                }
 671        }
 672
 673        make_valgrind_symlink () {
 674                # handle only executables
 675                test -x "$1" || return
 676
 677                base=$(basename "$1")
 678                symlink_target=$TEST_DIRECTORY/../$base
 679                # do not override scripts
 680                if test -x "$symlink_target" &&
 681                    test ! -d "$symlink_target" &&
 682                    test "#!" != "$(head -c 2 < "$symlink_target")"
 683                then
 684                        symlink_target=../valgrind.sh
 685                fi
 686                case "$base" in
 687                *.sh|*.perl)
 688                        symlink_target=../unprocessed-script
 689                esac
 690                # create the link, or replace it if it is out of date
 691                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 692        }
 693
 694        # override all git executables in TEST_DIRECTORY/..
 695        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 696        mkdir -p "$GIT_VALGRIND"/bin
 697        for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
 698        do
 699                make_valgrind_symlink $file
 700        done
 701        OLDIFS=$IFS
 702        IFS=:
 703        for path in $PATH
 704        do
 705                ls "$path"/git-* 2> /dev/null |
 706                while read file
 707                do
 708                        make_valgrind_symlink "$file"
 709                done
 710        done
 711        IFS=$OLDIFS
 712        PATH=$GIT_VALGRIND/bin:$PATH
 713        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 714        export GIT_VALGRIND
 715elif test -n "$GIT_TEST_INSTALLED" ; then
 716        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 717        error "Cannot run git from $GIT_TEST_INSTALLED."
 718        PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
 719        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 720else # normal case, use ../bin-wrappers only unless $with_dashes:
 721        git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
 722        if ! test -x "$git_bin_dir/git" ; then
 723                if test -z "$with_dashes" ; then
 724                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 725                fi
 726                with_dashes=t
 727        fi
 728        PATH="$git_bin_dir:$PATH"
 729        GIT_EXEC_PATH=$TEST_DIRECTORY/..
 730        if test -n "$with_dashes" ; then
 731                PATH="$TEST_DIRECTORY/..:$PATH"
 732        fi
 733fi
 734GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 735unset GIT_CONFIG
 736GIT_CONFIG_NOSYSTEM=1
 737GIT_CONFIG_NOGLOBAL=1
 738export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 739
 740. ../GIT-BUILD-OPTIONS
 741
 742if test -z "$GIT_TEST_CMP"
 743then
 744        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 745        then
 746                GIT_TEST_CMP="$DIFF -c"
 747        else
 748                GIT_TEST_CMP="$DIFF -u"
 749        fi
 750fi
 751
 752GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 753export GITPERLLIB
 754test -d ../templates/blt || {
 755        error "You haven't built things yet, have you?"
 756}
 757
 758if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 759then
 760        GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
 761        export GITPYTHONLIB
 762        test -d ../git_remote_helpers/build || {
 763                error "You haven't built git_remote_helpers yet, have you?"
 764        }
 765fi
 766
 767if ! test -x ../test-chmtime; then
 768        echo >&2 'You need to build test-chmtime:'
 769        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 770        exit 1
 771fi
 772
 773# Test repository
 774test="trash directory.$(basename "$0" .sh)"
 775test -n "$root" && test="$root/$test"
 776case "$test" in
 777/*) TRASH_DIRECTORY="$test" ;;
 778 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 779esac
 780test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 781rm -fr "$test" || {
 782        GIT_EXIT_OK=t
 783        echo >&5 "FATAL: Cannot prepare test area"
 784        exit 1
 785}
 786
 787test_create_repo "$test"
 788# Use -P to resolve symlinks in our working directory so that the cwd
 789# in subprocesses like git equals our $PWD (for pathname comparisons).
 790cd -P "$test" || exit 1
 791
 792this_test=${0##*/}
 793this_test=${this_test%%-*}
 794for skp in $GIT_SKIP_TESTS
 795do
 796        to_skip=
 797        for skp in $GIT_SKIP_TESTS
 798        do
 799                case "$this_test" in
 800                $skp)
 801                        to_skip=t
 802                esac
 803        done
 804        case "$to_skip" in
 805        t)
 806                say_color skip >&3 "skipping test $this_test altogether"
 807                say_color skip "skip all tests in $this_test"
 808                test_done
 809        esac
 810done
 811
 812# Provide an implementation of the 'yes' utility
 813yes () {
 814        if test $# = 0
 815        then
 816                y=y
 817        else
 818                y="$*"
 819        fi
 820
 821        while echo "$y"
 822        do
 823                :
 824        done
 825}
 826
 827# Fix some commands on Windows
 828case $(uname -s) in
 829*MINGW*)
 830        # Windows has its own (incompatible) sort and find
 831        sort () {
 832                /usr/bin/sort "$@"
 833        }
 834        find () {
 835                /usr/bin/find "$@"
 836        }
 837        sum () {
 838                md5sum "$@"
 839        }
 840        # git sees Windows-style pwd
 841        pwd () {
 842                builtin pwd -W
 843        }
 844        # no POSIX permissions
 845        # backslashes in pathspec are converted to '/'
 846        # exec does not inherit the PID
 847        ;;
 848*)
 849        test_set_prereq POSIXPERM
 850        test_set_prereq BSLASHPSPEC
 851        test_set_prereq EXECKEEPSPID
 852        ;;
 853esac
 854
 855test -z "$NO_PERL" && test_set_prereq PERL
 856test -z "$NO_PYTHON" && test_set_prereq PYTHON
 857
 858# test whether the filesystem supports symbolic links
 859ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 860rm -f y